apps/web/lib/web/router.ex
defmodule Web.Router do
  use Web, :router

  pipeline :browser do
    plug(:accepts, ["html"])
    plug(:fetch_session)
    plug(:fetch_flash)
    plug(:protect_from_forgery)
    plug(:put_secure_browser_headers)
    plug(Web.Plugs.SetLocale, "en")
  end

  pipeline :api do
    plug(:accepts, ["json"])
  end

  scope "/", Web do
    pipe_through(:browser)
  end

  scope "/api/v1", Web.API.V1 do
    pipe_through(:api)

    get("/events", EventController, :index)
    get("/events/types", EventController, :types)
    get("/events/:event_publicid/cities", EventController, :cities)
    get("/events/:event_publicid/past-seismicity", EventController, :past_seismicity)
    get("/events/:event_publicid/phases", EventController, :phases)

    get("/zones", ZoneController, :index)
    get("/zones/:zone_slug", ZoneController, :show)

    get("/zones/:zone_slug/stations", ZoneController, :stations)

    get("/stations", StationController, :index)
    # get("/stations/:station_code", StationController, :show)
  end

  scope "/fdsnws/event/1", Web do
    pipe_through(:browser)

    get("/", FDSNEventController, :base)
    get("/query", FDSNEventController, :query)
    get("/application.wadl", FDSNEventController, :wadl)
    get("/catalogs", FDSNEventController, :catalogs)
    get("/contributors", FDSNEventController, :contributors)
    get("/version", FDSNEventController, :version)
  end

  scope "/:locale", Web do
    pipe_through(:browser)

    get("/search", EventController, :search)
    get("/search/results", EventController, :search_results)

    # get("/", PageController, :index, as: :index_with_locale)

    # scope "/actors" do
    #   get("/", PageController, :actors)
    # end

    get("/dashboards/:zone_slug", PageController, :dashboard)

    # get("/pages/:page_slug", PageController, :page)

    # get("/about", PageController, :about)
    # get("/webservices", PageController, :webservices)
    # get("/contact", PageController, :contact)
    # get("/:zone_slug", PageController, :zone)
    # get("/:zone_slug/stations", PageController, :zone_stations)

    # scope "/events" do
    #   get("/:event_id", EventController, :show)
    # end

    # scope "/testimony", as: :testimony do
    #   get("/new", TestimonyController, :new)
    #   get("/new/address", TestimonyController, :witness_address)
    #   get("/:testimony_key", QuestionController, :question)

    #   post("/new/address", TestimonyController, :witness_address)
    #   post("/:testimony_key", QuestionController, :form_proceed)
    #   post("/:testimony_key/next_question", QuestionController, :next_question)
    # end
  end
end

apps/web/lib/web/api/v1/event_controller.ex
defmodule Web.API.V1.EventController do
  use Web, :controller

  alias Namazu.Seismic.Event
  alias Namazu.Geography.Area
  alias Namazu.Geography.City
  alias Namazu.Instruments.Station
  import Namazu.Helpers

  def get_geometry(event = %Event{}) do
    event.preferred_origin.location
  end

  def get_geometry(area = %Area{}) do
    area.location
  end

  def get_geometry(station = %Station{}) do
    List.first(station.periods).location
  end

  def get_properties(event = %Event{}) do
    %{
      eventID: event.id,
      time: event.preferred_origin.time,
      magnitude: event.preferred_magnitude.magnitude,
      eventType: event.event_type,
      automatic: event.preferred_origin.automatic
    }
  end

  def get_properties(area = %City{}) do
    %{
      areaID: area.id,
      population: area.population,
      countryISO2: area.country_iso2,
      name: area.name,
      distance: area.distance
    }
  end

  def get_properties(area = %Area{}) do
    %{
      areaID: area.id,
      population: area.population,
      countryISO2: area.country_iso2,
      name: area.name,
      distance: area.distance
    }
  end

  def get_properties(station = %Station{}) do
    %{
      networkcode: station.network.network_code,
      networkcolor: station.network.color,
      stationcode: station.station_code
    }
  end

  def to_feature(zone) do
    Web.Helpers.to_feature(zone, &__MODULE__.get_properties/1, &__MODULE__.get_geometry/1)
  end

  def cities(conn, _params = %{"event_publicid" => event_publicid}) do
    cities =
      Web.Cache.get_distintive_cities(event_publicid)
      |> Enum.map(&__MODULE__.to_feature(&1))
      |> Web.Helpers.geojson()

    json(conn, cities)
  end

  def past_seismicity(conn, _params = %{"event_publicid" => event_publicid}) do
    events =
      Web.Cache.get_past_seismicity(event_publicid)
      |> Enum.map(&__MODULE__.to_feature(&1))
      |> Web.Helpers.geojson()

    json(conn, events)
  end

  def format_phase(phase) do
    %{
      arrivalID: phase.id,
      originID: phase.origin_id,
      pickID: phase.pick.id,
      networkCode: phase.pick.stream.network_code,
      stationCode: phase.pick.stream.station_code,
      locationCode: phase.pick.stream.location_code,
      channelCode: phase.pick.stream.channel_code,
      azimuth: phase.azimuth,
      distance: phase.distance,
      phaseCode: phase.phase_code,
      time: phase.pick.time,
      timeResidual: phase.time_residual,
      automatic: phase.pick.automatic
    }
  end

  def phases(conn, _params = %{"event_publicid" => event_publicid}) do
    phases =
      Web.Cache.get_preferred_origin_phases(event_publicid)
      |> Enum.map(&Web.API.V1.EventController.format_phase(&1))

    json(conn, phases)
  end

  def types(conn, _params) do
    types =
      Web.Cache.get_event_types()
      |> Enum.map(fn type ->
        %{name: type.event_type, count: type.count}
      end)

    json(conn, types)
  end

  def index(conn, _params = %{"event_publicid" => event_publicid}) do
    event =
      [Web.Cache.get_event(event_publicid)]
      |> Enum.map(&__MODULE__.to_feature(&1))
      |> Web.Helpers.geojson()

    json(conn, [event])
  end

  def index(conn, params) do
    search = %Namazu.Search.EventSearch{
      start_time: params["start_time"],
      end_time: params["end_time"],
      minimal_longitude: parse_float(params["minimal_longitude"]),
      maximal_longitude: parse_float(params["maximal_longitude"]),
      minimal_latitude: parse_float(params["minimal_latitude"]),
      maximal_latitude: parse_float(params["maximal_latitude"]),
      minimal_magnitude: parse_float(params["minimal_magnitude"]),
      maximal_magnitude: parse_float(params["maximal_magnitude"]),
      minimal_depth: parse_float(params["minimal_depth"]),
      maximal_depth: parse_float(params["maximal_depth"]),
      event_types: String.split(params["event_types"], ","),
      limit: parse_integer(params["limit"]),
      offset: parse_integer(params["offset"]),
      order_by: parse_order_by(params["order_by"])
    }

    events =
      Namazu.Search.EventSearch.query(search)
      |> Namazu.Repo.all()
      |> Enum.map(&__MODULE__.to_feature(&1))
      |> Web.Helpers.geojson()

    json(conn, events)
  end

  # def show(conn, _params = %{"event_id" => event_id}) do
  #   json(conn, event)
  # end
end

apps/web/lib/web/controllers/event_controller.ex
defmodule Web.EventController do
  import Plug.Conn

  use Web, :controller

  require Web.Gettext

  import Namazu.Helpers,
    only: [
      parse_datetime: 1,
      parse_integer: 1,
      parse_order_by: 1
    ]

  alias Namazu.Repo
  alias Namazu.Seismic.Origin
  alias Namazu.Seismic

  import Ecto.Query

  def fdsn_query_path(event_search, format \\ nil) do
    params = Namazu.Search.EventSearch.fdsn_query_params(event_search)

    params =
      if format do
        Map.put(params, "format", format)
      else
        params
      end
      |> Enum.map(fn {key, value} -> {key, "#{value}"} end)
      |> Enum.into(%{})

    Web.Router.Helpers.fdsn_event_path(Web.Endpoint, :query, params)
  end

  def search(conn, _params = %{"locale" => locale}) do
    event_types =
      Web.Cache.get_event_types()
      |> Enum.filter(fn t -> not (t.event_type in ["not existing", "not locatable"]) end)

    title = Gettext.gettext(Web.Gettext, "Search")

    render(conn, "search.html", title: title, locale: locale, event_types: event_types)
  end

  def convert_start_date(start_date) do
    case start_date do
      "" -> nil
      nil -> nil
      start_date -> "#{start_date}T00:00:00Z" |> parse_datetime()
    end
  end

  def convert_end_date(end_date) do
    case end_date do
      "" -> nil
      nil -> nil
      end_date -> "#{end_date}T23:59:59.999999Z" |> parse_datetime()
    end
  end

  def search_results(conn, params = %{"locale" => locale}) do
    events_limit = 30
    query_params = Map.get(conn, :query_params)

    event_types =
      query_params
      |> Enum.filter(fn {key, value} ->
        String.starts_with?(key, "event_type_") and value == "true"
      end)
      |> Enum.map(fn {key, _value} -> String.slice(key, 11, 40) end)

    event_publicid =
      case Map.get(query_params, "event_id") do
        "" -> nil
        event_publicid -> event_publicid
      end

    search_params = %Namazu.Search.EventSearch{
      start_time: Map.get(query_params, "start_date") |> convert_start_date(),
      end_time: Map.get(query_params, "end_date") |> convert_end_date(),
      minimal_longitude:
        Map.get(query_params, "minimal_longitude") |> Namazu.Helpers.parse_float(),
      maximal_longitude:
        Map.get(query_params, "maximal_longitude") |> Namazu.Helpers.parse_float(),
      minimal_latitude: Map.get(query_params, "minimal_latitude") |> Namazu.Helpers.parse_float(),
      maximal_latitude: Map.get(query_params, "maximal_latitude") |> Namazu.Helpers.parse_float(),
      minimal_magnitude:
        Map.get(query_params, "minimal_magnitude") |> Namazu.Helpers.parse_float(),
      maximal_magnitude:
        Map.get(query_params, "maximal_magnitude") |> Namazu.Helpers.parse_float(),
      minimal_depth: Map.get(query_params, "minimal_depth") |> Namazu.Helpers.parse_float(),
      maximal_depth: Map.get(query_params, "maximal_depth") |> Namazu.Helpers.parse_float(),
      event_publicid: event_publicid,
      event_types: event_types,
      limit: Map.get(query_params, "limit") |> parse_integer(),
      offset: Map.get(query_params, "offset") |> parse_integer(),
      order_by: Map.get(query_params, "order_by") |> parse_order_by()
    }

    search_query = Namazu.Search.EventSearch.query(search_params)

    fdsn_xml_path = fdsn_query_path(search_params)

    geojson_path = fdsn_query_path(search_params, "json")

    fdsn_text_path = fdsn_query_path(search_params, "text")

    events_count = search_query |> Repo.aggregate(:count, :id)

    current_page = Map.get(params, "page", "1") |> String.to_integer()

    offset = events_limit * (current_page - 1)

    events =
      search_query
      |> Seismic.preload_distinctive_cities()
      |> offset(^offset)
      |> limit(^events_limit)
      |> Repo.all()

    title = Gettext.gettext(Web.Gettext, "Search results")

    event_uri_prefix = "event_uri_prefix_#{String.downcase(locale)}" |> Namazu.get_parameter()

    render(conn, "search_results.html",
      locale: locale,
      title: title,
      event_uri_domain: Namazu.get_parameter("event_uri_domain"),
      event_uri_prefix: event_uri_prefix,
      events_count: events_count,
      events_limit: events_limit,
      events: events,
      fdsn_xml_path: fdsn_xml_path,
      geojson_path: geojson_path,
      fdsn_text_path: fdsn_text_path
    )
  end
end

apps/web/lib/web/views/event_view.ex
defmodule Web.EventView do
  use Web, :view

  import Web.Filters
  alias Namazu.Seismic.Event
end

apps/web/lib/web/templates/event/events_table.html.eex
<%
event_chunks = Event.chunk_by_local_date(@events)
%>

<%= for chunk <- event_chunks do %>
<%
{local_time, _first_event} = List.first(chunk)
%>
<table class="table is-narrow">
  <thead>
    <tr>
      <th colspan="3"><%= format_date_text(local_time, @locale) %></th>
    </tr>
  </thead>
  <tbody>
    <%= for {local_time, event} <- chunk do %>
    <tr>
      <td><%= automatic_icon(event.preferred_origin.automatic) %></td>
      <td><%= format_time(local_time, false) %></td>
      <td>
        <a href="https://<%= @domain %><%= @event_uri_prefix %>/<%= event.publicid %>" target="_blank">
          <%= Web.Filters.event_description(event) %>&nbsp;<%= country_flag(@conn, event.distinctive_city.country_iso2) %>
        </a>
      </td>
    </tr>
    <% end %>
  </tbody>
</table>
<% end %>
<div class="content">
  <nav role="navigation" class="pagination" aria-label="pagination">
    <%= if @previous_link do %>
    <a class="pagination-previous" href="<%= @previous_link %>"><%= @previous_label %></a>
    <% else %>
    <a class="pagination-previous" disabled><%= @previous_label %></a>
    <% end %>
    <%= if @next_link do %>
    <a class="pagination-next" href="<%= @next_link %>"><%= @next_label %></a>
    <% else %>
    <a class="pagination-next" disabled><%= @next_label %></a>
    <% end %>
  </nav>
</div>

apps/web/lib/web/templates/event/search.html.eex
<section class="section">
  <div class="container">
    <%= form_for @conn, Routes.event_path(@conn, :search_results, @locale), [method: :get], fn form -> %>
        <div id="tabs-with-content">
          <div class="tabs is-boxed is-medium">
            <ul>
              <li>
                <a><%= gettext "Basic filters" %></a>
              </li>
              <li>
                <a><%= gettext "Advanced filters" %></a>
              </li>
            </ul>
          </div>
          <div>
            <section class="tab-content is-active">
              <div class="columns is-multiline">
                <div class="column is-one-third">
                  <%= Web.Bulma.date_input(form, :start_date, gettext("Start date"), "calendar-minus") %>
                </div>
                <div class="column is-one-third">
                  <%= Web.Bulma.date_input(form, :end_date, gettext("End date"), "calendar-plus") %>
                </div>
              </div>
              <hr>
              <div class="columns is-centered">
                <div class="column is-one-third">
                  <%= Web.Bulma.number_input(form, :maximal_latitude, gettext("Maximal latitude"), "arrow-up", step: 0.01) %>
                </div>
              </div>
              <div class="columns is-mobile is-centered">
                <div class="column">
                  <%= Web.Bulma.number_input(form, :minimal_longitude, gettext("Minimal longitude"), "arrow-left", step: 0.01) %>
                </div>
                <div class="column is-one-third-desktop is-narrow">
                </div>
                <div class="column">
                  <%= Web.Bulma.number_input(form, :maximal_longitude, gettext("Maximal longitude"), "arrow-right", step: 0.01) %>
                </div>
              </div>
              <div class="columns is-centered">
                <div class="column is-one-third">
                  <%= Web.Bulma.number_input(form, :minimal_latitude, gettext("Minimal latitude"), "arrow-down", step: 0.01) %>
                </div>
              </div>
              <hr>
              <div class="columns is-multiline">
                <div class="column is-one-third">
                  <%= Web.Bulma.number_input(form, :limit, gettext("Limit"), "stop") %>
                </div>
                <div class="column is-one-third">
                  <%= Web.Bulma.number_input(form, :offset, gettext("Offset"), "forward") %>
                </div>
                <div class="column is-one-third">
                  <%= Web.Bulma.select(form, :order_by, [
                    [key: gettext("Descending time"), value: :descending_time],
                    [key: gettext("Ascending time"), value: :ascending_time],
                    [key: gettext("Descending magnitude"), value: :descending_magnitude],
                    [key: gettext("Ascending magnitude"), value: :ascending_magnitude]
                  ], gettext("Order by"), "stream") %>
                </div>
              </div>
            </section>
            <section class="tab-content is-active">
              <div class="columns">
                <div class="column is-half">
                  <div class="content">
                    <%= Web.Bulma.number_input(form, :minimal_magnitude, gettext("Minimal magnitude"), "arrow-down", step: 0.1) %>
                    <%= Web.Bulma.number_input(form, :maximal_magnitude, gettext("Maximal magnitude"), "arrow-up", step: 0.1) %>
                    <hr>
                    <%= Web.Bulma.number_input(form, :minimal_depth, gettext("Minimal depth"), "arrow-down") %>
                    <%= Web.Bulma.number_input(form, :maximal_depth, gettext("Maximal depth"), "arrow-up") %>
                    <hr>
                    <%= Web.Bulma.text_input(form, :event_id, gettext("Event ID"), "stream") %>
                  </div>
                </div>
                <div class="column is-half">
                  <div class="content">
                    <%= Web.Bulma.label(gettext "Event types") %>
                    <%= for event_type <- @event_types do %>
                      <% translated_event_type = Gettext.dgettext(Web.Gettext, "event_types", event_type.event_type) |> String.capitalize() %>
                      <p class="control"></p>
                      <label class="checkbox">
                        <%= checkbox(form, "event_type_#{event_type.event_type}" |> String.to_atom() ) %>
                        &nbsp;<%= translated_event_type %>
                        <span class="tag is-link is-normal"><%= event_type.count %></span>
                      </label>
                      </p>
                    <% end %>
                  </div>
                </div>
              </div>
            </section>
          </div>
        </div>
      <hr>
      <div class="columns">
        <div class="column">
          <%= Web.Bulma.reset(gettext "Reset") %>
        </div>
        <div class="column">
          <%= Web.Bulma.submit(gettext "Search") %>
        </div>
      </div>
    <% end %>
  </div>
</section>
<script src="<%= Routes.static_path(@conn, "/js/tabs.js") %>"></script>
<script type="text/javascript">
  document.addEventListener('DOMContentLoaded', (event) => {
    Tabs('tabs-with-content')
  })
</script>

apps/web/lib/web/templates/event/search_results.html.eex
<section class="section">
  <div class="container">
    <div class="content">
      <%= if @events_count > 0 do %>
        <p>
          <%= ngettext "You search returns one event.", "Your search returns %{events_count} events.", @events_count, events_count: @events_count %>
          <%= gettext "You can download your search result using one of the following formats :" %>
        </p>
        <div class="columns">
          <div class="column">
            <div class="card">
              <header class="card-header">
                <p class="card-header-title">
                  FDSN-Event webservice
                </p>
              </header>
              <div class="card-content">
                <p>
                <%= gettext "XML standard developped by the research community." %>
                <%= gettext "Researchers looking for the maximum information should use this format as it contains almost every event parameters." %>
                </p>
                <p>
                <%= gettext("QuakeML documentation is available on the %{link}.", link: safe_to_string(link(gettext("FDSN website"), to: "https://www.fdsn.org/webservices/fdsnws-event-1.2.pdf"))) |> raw() %>
                </p>
              </div>
              <footer class="card-footer">
                <a class="card-footer-item" href="<%= @fdsn_xml_path %>" download="events.xml">Download QuakeML</a>
                <a class="card-footer-item" href="<%= @fdsn_text_path %>" download="events.txt">Download Text</a>
              </footer>
            </div>
          </div>
          <div class="column">
            <div class="card">
              <header class="card-header">
                <p class="card-header-title">
                  GeoJSON
                </p>
              </header>
              <div class="card-content">
                <p>
                <%= gettext "JSON standard that can be easily parsed by developpers." %>
                <%= gettext("You can also easily open the link in GIS software like %{qgis_link}.", qgis_link: safe_to_string(link("QGIS", to: "https://www.qgis.org"))) |> raw() %>
                </p>
              </div>
              <footer class="card-footer">
                <a class="card-footer-item" href="<%= @geojson_path %>" download="events.json">Download GeoJSON</a>
              </footer>
            </div>
          </div>
        </div>
      <% else %>
        <%= gettext "Your search returns no event." %>
      <% end %>
      <hr>
      <%= events_table(@conn, @locale, @events, @events_count, @events_limit, @event_uri_domain, @event_uri_prefix, gettext("Previous page"), gettext("Next page")) %>
    </div>
  </div>
</section>